# Set class
# written by MOROHOSHI Akihiko <moro@nii.ac.jp>
# $Id: set.rb,v 1.2 2001/07/29 01:43:58 moro Exp $

class Set
    def initialize
	@hash = {}
    end
    def add(obj)
	@hash[obj] = obj
    end
    
    def delete(obj)
	@hash.delete obj
    end
    def include?(obj)
	@hash.include? obj
    end
    def delete_if(&block)
	@hash.delete_if { |k,v|
	    block.call(k)
	}
    end
    def size
	@hash.size
    end
    
    # if include objects equivalent to obj, return it.
    # otherwise, return nil.
    def [](obj)
	@hash[obj]
    end
    def find(&block)
	r = @hash.find { |k,v|
	    block.call(k)
	}
	if r
	    r[0]
	else
	    nil
	end
    end
end
