# flyweight tag name
# $Id$

class TagName
    TAG_NAMES = [
	'B','S','I','U',
	'0','1','2','3','4','5','6','7','8','9',
	'r','g','b','c','m','y','k','w',
	'EM','PL','TT'
    ]

    def initialize(name)
	@name = name
    end
    attr_reader :name
    
    def to_str
	@name
    end

    def hash
	@name.hash
    end

    def eql?(other)
	self == other
    end

    def ==(other)
	other.type == self.type and other.name == @name
    end

    Str2TagName = {}

    module Constants
    end
    
    TAG_NAMES.each do |name|
	tag = TagName.new(name)
	Str2TagName[name] = tag
	Str2TagName[name.intern] = tag
	Constants.const_set("TAG_#{name}", tag)
    end

    def self.get(name)
	Str2TagName[name]
    end
    
    class <<self
	private :new
    end
end

if __FILE__ == $0
    (TagName::TAG_NAMES).each do |name|
	print "#{name} => "
	p TagName.get(name)
    end

    print "\n"

    (TagName::Constants).constants.each do |name|
	if /^TAG_/ =~ name
	    print "#{name} => "
	    p ((TagName::Constants).const_get(name))
	end
    end

    print "\n"

    p TagName.get('EM') == TagName::Constants::TAG_EM # => true

    p TagName.new('EM')		# => error
end
